<%@ Page Language="C#" Debug="true" %>

<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="System.Reflection" %>

<%@ Import Namespace="Persits.PDF" %>



<script runat="server" LANGUAGE="C#">

void Page_Load(Object Source, EventArgs E)
{
	lblResult.Text = "";

	// to keep sessionID (used for file name generation) from changing every time
	Session["dummy"] = 1; 

	// Initialize checkboxes to their default values
	if( !IsPostBack )
	{
		flatten.Checked = true;
		removejavascript.Checked = true;
		reset.Checked = true;
	}
}



public void FlattenForm(object sender, System.EventArgs args)
{
	// file uploaded?
    if( pdfform.PostedFile.FileName.Length > 0 )
    {
		if( pdfform.PostedFile.ContentLength > 310000 )
		{
			lblResult.Text = "<font color=red><B>Uploaded file exceeds 300KB. Please select a smaller file.</B></font>";
			return;
		}

		// Save file
        string strUploadPath = Server.MapPath("files");
		strUploadPath += "\\" + System.IO.Path.GetFileName(pdfform.PostedFile.FileName);

        pdfform.PostedFile.SaveAs(strUploadPath);


		try
		{
			// create instance of the PDF manager
			PdfManager objPDF = new PdfManager();

			// Create new document
			PdfDocument objDoc = objPDF.OpenDocument( strUploadPath );

			PdfParam objParam = objPDF.CreateParam();

			if( flatten.Checked )
				objParam["flatten"] = 1;

			if( flattenannots.Checked )
				objParam["flattenannots"] = 1;

			if( removejavascript.Checked )
				objParam["removejavascript"] = 1;

			if( reset.Checked )
				objParam["reset"] = 1;

			// Flatten form using used-specified parameters
			objDoc.Form.Modify( objParam );
		

			// We use Session ID for file names.
			// false means "do not overwrite"
			// The method returns generated file name.
			String strPath = Server.MapPath( "files") + "\\flatten_" + Session.SessionID + ".pdf";
			String strFileName = objDoc.Save( strPath, false );

			lblResult.Text = "Success. Your PDF file <font color=gray>" + strFileName + "</font> can be downloaded <A TARGET=\"_new\" HREF=\"files/" + strFileName + "\"><B>here</B></A>.";

			objDoc.Close();
		}
		catch( Exception e )
		{
			lblResult.Text = "An error occurred: <font color=red>" + e.Message + "</font>";
		}
	}
}

</script>


<html>
<head>
<title>AspPDF.NET Form Flattening Online Demo</title>
</head>



<body>
<font face="Arial" size="2">

<h3>AspPDF Form Flattening Online Demo</h3>

<P>
<table STYLE="font-type: arial; font-size: 13; border: 0" width="600">
<tr>
<td colspan="2">
Please upload a PDF form from your computer to our server. AspPDF.NET will flatten the form
and let you download the flattened PDF document.
</td>

</tr>
<tr><td colspan="2">&nbsp;</td></tr>

<form runat="server">
<tr>
	<td>Select a PDF form:</td>
	
	<td><asp:FileUpload ID="pdfform" runat="server"/></td>
</tr>

<tr>
	<td valign="top">Choose flattening options:</td>
	<td>
		<asp:checkbox runat="server" type="checkbox" id="flatten"/> Flatten Form Items<BR>
		<asp:checkbox runat="server" type="checkbox" id="flattenannots"/> Flatten Annotations<BR>
		<asp:checkbox runat="server" type="checkbox" id="removejavascript"/> Remove JavaScript<BR>
		<asp:checkbox runat="server" type="checkbox" id="reset"/> Reset Graphics State<BR>	
	</td>
</tr>

<tr>
	<td colspan="2"><asp:button OnClick="FlattenForm" ID="btnFlatten" Text="Flatten Form" runat="server"/></td>
</tr>

<tr>
	<td colspan="2"><asp:label ID="lblResult" runat="server"/></td>
</tr>
	
</form>

</table>

<P>



<P>
<b><a href="demo_flatten.zip">Download source code (C#/VB.NET) for this demo</a></b>
</font>
</body>
</html>
